package meerkat.mixer;

/**
 * Created by Tzlil on 12/17/2015.
 */

import meerkat.mixer.mixing.MixNetwork;
import meerkat.mixer.mixing.RandomPermutation;
import meerkat.mixer.mixing.Switch;
import org.junit.Test;
import java.util.Arrays;
import java.util.Random;

public class MixNetworkTest {

    @Test
    public void testMixNetwork()  throws Exception{

        Random random = new Random();
        int logn = 10;
        int n = 1 << logn;
        int layers = 2*logn - 1;
        RandomPermutation randomPermutation = new RandomPermutation(n,random);
        MixNetwork mixNetwork = new MixNetwork(randomPermutation);

        //initialize arr s.t arr[i] = i
        int[] arr = new int[n];
        for (int i = 0; i < n ;i ++)
            arr[i] = i;

        // layer by layer swap between values
        for (int layer = 0 ; layer< layers ; layer ++) {
            for (Switch sw : mixNetwork.getSwitchesByLayer(layer)) {
                if(sw.value) {
                    arr[sw.i] += arr[sw.j];
                    arr[sw.j] = arr[sw.i] - arr[sw.j];
                    arr[sw.i] -= arr[sw.j];
                }
            }
        }

        assert(Arrays.equals(arr,randomPermutation.permutation));

    }

}
